routes/web.php
<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\AnnounceController;
use App\Http\Controllers\CompanyController;



/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/




Auth::routes();
Route::get('/', [HomeController::class, 'front'])->name('front');
Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');
//Route::get('announce_add/save', [AnnounceController::class, 'saveRecord'])->name('announce_add/save');

Route::resource('role', RoleController::class);
Route::resource('user', UserController::class);
Route::resource('announce', AnnounceController::class);
// Route::resource('announce_list', AnnounceController::class);
//Route::resource('announce_add', AnnounceController::class);

Route::resource('company', CompanyController::class);
Route::get('reports',[HomeController::class, 'reportForm'])->name('report.form');
Route::get('rfq/report',[HomeController::class, 'rfqReport'])->name('rfq.report');
Route::get('company/list/{id}',[HomeController::class, 'companyList'])->name('company.list');

Route::view('/test', 'layouts.main');

app/Models/Announce.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Announce extends Model
{
    

    use HasFactory;

    public function category()
    {
        return $this->belongsTo(AnsCategory::class);
    }

    public function company()
    {
        return $this->belongsToMany(Company::class, 'histories');
    }
}

app/Http/Controllers/AnnounceController.php
<?php

namespace App\Http\Controllers;

use App\Models\Announce;
use App\Models\AnsCategory;
use Illuminate\Http\Request;
use Brian2694\Toastr\Facades\Toastr;

class AnnounceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    { 
        $announce_list =  Announce::all();
      
        return  view('announce.index', ['announce_list' => $announce_list ] );

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $categories = AnsCategory::all();

        return view('announce.create', compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $validated = $request->validate([
            'rfq_no' => 'required|unique:announces',
            // 'body' => 'required',
        ]);
        $announce_add = new Announce;
        $announce_add->title = $request->title;
        $announce_add->rfq_no = $request->rfq_no;
         $announce_add->content = $request->announce_content;
         $announce_add->category_id = $request->category_id;
         $announce_add->start_date = $request->start_date;
         $announce_add->end_date = $request->end_date;
         $announce_add->status = $request->status;
         
         $ext = $request->file('data')->getClientOriginalExtension();
         
         $filename = md5(time()).".".$ext;
        // dd($request->all());
       if($ext == "pdf"){
        $request->file('data')->storeAs('public/pdf/',$filename );
       }else{
        return redirect()->route('announce.create')->with('message', 'Please select .pdf file');
       }
    //    dd($request->all());

        $announce_add->path = $filename;
        $announce_add->save();

         return redirect()->route('announce.index')->with('message', 'Announce Number '.$request->title.'  adeded succssfully');
         Toastr::success('Post added successfully :)','Success');
    }
    
    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Announce  $announce
     * @return \Illuminate\Http\Response
     */
    public function show(Announce $announce)
    {
        return view('front.show',compact('announce'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Announce  $announce
     * @return \Illuminate\Http\Response
     */
    public function edit(Announce $announce)
    {
        $categories = AnsCategory::all();
        return view('announce.edit',['announce'=> $announce,"categories"=> $categories]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Announce  $announce
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Announce $announce)
    {
        //
        $request->validate([
            'rfq_no' => 'required|unique:announces,rfq_no,'.$announce->id,
        ]);

        // $validated = $request->validate([
        //     'rfq_no' => 'required|unique:announces',
        //     // 'body' => 'required',
        // ]);
        $announce->title = $request->title;
        $announce->rfq_no = $request->rfq_no;
        $announce->content = $request->announce_content;
        $announce->category_id = $request->category_id;
        $announce->start_date = $request->start_date;
        $announce->end_date = $request->end_date;
        $announce->status = $request->status;
        
        if ($request->hasFile('data')) {
            $ext = $request->file('data')->getClientOriginalExtension();
        
            $filename = $request->title.".".$ext;
    
            if($ext == "pdf"){

                $request->file('data')->storeAs('public/pdf/',$filename );
            }
            else{
                return redirect()->route('announce.create')->with('message', 'Please select .pdf file');
            }

            $announce_add->path = $filename;
        }

        $announce->save();

        return redirect()->route('announce.index')->with('message', 'Announce Number '.$request->title.'  adeded succssfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Announce  $announce
     * @return \Illuminate\Http\Response
     */
    public function destroy(Announce $announce)
    {
        $announce->delete();
        return redirect()->route('announce.index')->with('message', __('general.record_deleted'));
    }
}

resources/views/announce/create.blade.php
@extends('app')

@section('page_title',__('general.announcement_add'))

@section('body')

<section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <!-- /.card -->
          <div class="card">

            <div class="card-body">
              <form method="POST" action="{{ route('announce.store') }}" enctype="multipart/form-data">
                @method('post')
                @csrf
                <div class="row">
                  <div class="col-md-8">
                    <div class="form-group">
                      <label for="title">{{__('general.title')}}<span class="text-danger"> * </span></label>
                      <input value="{{ old('title') }}" type="text" class="form-control" id="title" name="title" required>
                     @error('page')
                      <span style="color: red;"> * {{ $message }} </span>
                      @enderror
                    </div>
                    <div class="form-group">
                      <label for="rfq_no">{{__('general.RFQ_no')}}<span class="text-danger"> * </span></label>
                      <input value="{{ old('rfq_no') }}" type="text" class="form-control" id="rfq_no" name="rfq_no" required>
                     @error('rfq_no')
                      <span style="color: red;"> * {{ $message }} </span>
                      @enderror
                    </div>
                    <br>
                    <div class="form-group">
                      <label for="role_name">{{__('general.announce_content')}}<span class="text-danger"> * </span></label>
                      <textarea id="summernote" name="announce_content" required></textarea>

                       @error('page')
                        <span style="color: red;">*  {{ $message }} </span>
                       @enderror
                    </div>
                  </div>
                  <div class="col-md-4">
                    <div class="form-group">
                      <label for="category_id">{{__('general.announce_category')}}<span class="text-danger"> * </span></label>
                      <select class="form-control" style="width: 100%;" name="category_id" required>
                        <option value="">{{__('general.choose_category')}}</option>
                        @foreach($categories as $category)
                            <option value="{{ $category->id }}">{{ $category->description }}</option>
                        @endforeach
                      </select>
                      @error('page')
                          <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>
                    <div class="form-group">
                      <label>{{__('general.announce_status')}}<span class="text-danger"> * </span></label>
                      <select class="form-control select2" style="width: 100%;" name="status" required>
                        <option value="">{{__('general.choose_status')}}</option>
                        <option value="active">{{__('general.active')}}</option>
                        <option value="deactive">{{__('general.deactive')}}</option>
                       
                      </select>
                      @error('type')
                          <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>
                     
                    
                    <div class="form-group">
                      {{-- <label for="start_date">{{__('general.start_date')}}<span class="text-danger"> * </span></label> --}}
                      <input value="{{ old('start_date') }}" type="hidden" class="form-control jalali-date"  name="start_date" readonly >
                    @error('date')
                        <span style="color: red;">*  {{ $message }} </span>
                    @enderror
                    </div>
                    <div class="form-group">
                      <label for="end_date">{{__('general.Ans_EndDate')}}<span class="text-danger"> * </span></label>
                      <input value="{{ old('end_date') }}" type="text" class="form-control jalali-date"  name="end_date">
                    @error('date')
                        <span style="color: red;">*  {{ $message }} </span>
                    @enderror
                    </div>
                    
                    <div class="form-group">
                      <label for="exampleInputFile">انتخاب فایل<span class="text-danger"> * </span></label>
                      <div class="input-group">
                        <div class="custom-file">
                          <input type="file" id="myfile" name="data" ><br><br>
                        </div>
                      </div>
                    </div>
                    
                    
                    <div class="row mb-0">
                      <div class="col-md-6 offset-md-4">
                          <button type="submit" class="btn btn-primary" style="text-align: center" >
                              {{ __('general.announce_add') }}
                          </button>
                      </div>
                  </div>
                </div>
              </form>
            </div>
            <!-- /.card-body -->
          </div>
          <!-- /.card -->
        </div>
        <!-- /.col -->
      </div>
      <!-- /.row -->
    </div>
    <!-- /.container-fluid -->
  </section>

@endsection

@pushOnce('datatables-script')

<link href="{{ asset('/summernote/summernote.css') }}" rel="stylesheet">
<script src="{{ asset('/summernote/bootstrap.min.js') }}"></script>
<script src="{{ asset('/summernote/summernote.min.js') }}">
</script>

<script>
  $(document).ready(function() {
      $('#summernote').summernote({
        placeholder: 'دیتای اعلانات شاروالی کابل',
        tabsize: 2,
        height: 300
      });

  });
</script>
@endpushOnce

resources/views/announce/edit.blade.php
@extends('app')

@section('page_title',__('general.announcement_add'))

@section('body')
<section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <!-- /.card -->
          <div class="card">

            <div class="card-body">
              
              <form method="POST" action="{{ route('announce.update', $announce->id) }}" enctype="multipart/form-data">
                @method('PUT')
                @csrf
                <div class="row">
                  <div class="col-md-8">
                    <div class="form-group">
                      <label for="title">{{__('general.announce_title')}}</label>
                      <input  type="text" class="form-control" id="title" name="title" value="{{ $announce->title }}">
                     @error('page')
                      <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>
                    <div class="form-group">
                      <label for="rfq_no">{{__('general.RFQ_no')}}</label>
                      <input  type="text" class="form-control" id="rfq_no" name="rfq_no" value="{{ $announce->rfq_no }}">
                     @error('rfq_no')
                      <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>
                    <div class="form-group">
                      <label for="role_name">{{__('general.announce_content')}}</label>
                      <textarea id="summernote" name="announce_content" > {{ $announce->content }} </textarea>
                    
                       @error('page')
                        <span style="color: red;">*  {{ $message }} </span>
                       @enderror
                    </div>
                    
                  </div>
                  <div class="col-md-4">
                    <div class="form-group">
                      <label for="category_id">{{__('general.announce_category')}}</label>
                      <select class="form-control" style="width: 100%;" name="category_id" >
                        <option value="">{{__('general.choose_category')}}</option>
                        @foreach($categories as $category)
                            <option value="{{ $category->id }}" @if($announce->category_id == $category->id) selected @endif >{{ $category->description }}</option>
                        @endforeach
                      </select>
                     @error('page')
                      <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>
                    <div class="form-group">
                      <label>{{__('general.type')}}<span class="text-danger"> * </span></label>
                      <select class="form-control" style="width: 100%;" name="status">
                          <option value="">{{__('general.select')}}</option>
                          <option value="active" @if($announce->status == 'active') selected @endif>{{__('general.active')}}</option>
                          <option value="deactive" @if($announce->status == 'deactive') selected @endif>{{__('general.deactive')}} </option>
                          @error('type')
                             <span style="color: red;">*  {{ $message }} </span>
                          @enderror
                      </select>
                    </div>
                    
                    <div class="form-group">
                      <label for="start_date">{{__('general.start_date')}}<span class="text-danger"> * </span></label>
                      <input id="start_date" value="{{ $announce->start_date }}" class="form-control"  name="start_date" readonly >
                    @error('start_date')
                        <span style="color: red;">*  {{ $message }} </span>
                    @enderror
                    </div>
                    <div class="form-group">
                      <label for="end_date">{{__('general.end_date')}}<span class="text-danger"> * </span></label>
                      <input type="text" id="end_date" class="form-control jalali-date"  name="end_date" value="{{ $announce->end_date }}">
                    @error('date')
                        <span style="color: red;">*  {{ $message }} </span>
                    @enderror
                    </div>
                    <div class="form-group">
                      <label for="exampleInputFile">{{__('general.choose_file')}}<span class="text-danger"> * </span></label>
                      <div class="input-group">
                    <div class="custom-file">
                      <input type="file" id="myfile" name="myfile" value="{{ old('path') }}"><br><br>
                    </div>
                      </div>
                    </div>
                    <div class="row mb-0">
                      <div class="col-md-6 offset-md-4">
                          <button type="submit" class="btn btn-primary">
                              {{ __('general.announce_add') }}
                          </button>
                      </div>
                      
                  </div>
                  <br>
                 
              </form>
            </div>
            <!-- /.card-body -->
          </div>
          <!-- /.card -->
        </div>
        <!-- /.col -->
      </div>
      <!-- /.row -->
    </div>
    <!-- /.container-fluid -->
  </section>
 
@endsection

@pushOnce('datatables-script')

<link href="{{ asset('/summernote/summernote.css') }}" rel="stylesheet">
<script src="{{ asset('/summernote/bootstrap.min.js') }}"></script>
<script src="{{ asset('/summernote/summernote.min.js') }}"></script>

<script>
  $(document).ready(function() {
      $('#summernote').summernote({
        placeholder: 'دیتای اعلانات شاروالی کابل',
        tabsize: 2,
        height: 300
      });

  });

    $( document ).ready(function() {

    let start_date = {!! json_encode($announce->start_date) !!};
    let end_date = {!! json_encode($announce->end_date) !!};;
    let x = document.getElementById('end_date');
    let y = document.getElementById('start_date');
      y.value = start_date
      x.value = end_date;
    });
   
</script>
@endpushOnce

resources/views/announce/index.blade.php
@extends('app')
@section('body')
<script src="{{ asset('/plugins/bootstrap/js/bootstrap.bundle.min.js') }}"></script>
@if ($message = session('message'))
<div class=".toastrDefaultSuccess">
  <p class="text-success">
    <b><i class="fas fa-info"></i></b> {{ $message }}
  </p>
</div>
@endif
<div class="card">
  
    <div class="card-header">
      <h3 class="card-title"></h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
      <div id="example1_wrapper" class="dataTables_wrapper dt-bootstrap4">
        <div class="row">
          <div class="col-sm-12 col-md-6"></div>
        </div>
      </div>
    
    <table id="example1" class="table table-bordered table-striped dataTable dtr-inline" aria-describedby="example1_info">
        <thead>
          <tr>
            <th>{{ __('general.RFQ_no') }} </th>
            <th>{{ __('general.title') }} </th>
            <th>{{ __('general.category') }}</th>
            <th>{{ __('general.start_date') }}</th>
            <th>{{ __('general.end_date') }}</th>
            <th>{{ __('general.options') }}</th>
          </tr>
          </thead>
        <tbody>
          @foreach ($announce_list as $item)
          <tr class="odd">
            <td>{{ $item->rfq_no }}</td>
            <td class="dtr-control sorting_1" tabindex="0"> {{ $item->title }}</td>
            <td> {{ $item->category->description }}</td>
            <td>{{ $item->start_date }}</td>
            <td>{{ $item->end_date }}</td>
            <td>{{ $item->options }}
            
                <a class="btn btn-info btn-xs" href="{{ route('announce.edit', $item->id)}}">{{__('general.edit') }}</a>
                <a class="btn btn-primary btn-xs" href="{{ route('announce.show',$item->id)}}">{{__('general.view') }}</a>
                <a class="btn btn-danger btn-xs" onclick="confirmDelete({{ $item->id}})" href="#">{{__('general.delete')}}</a>
                <a class="btn btn-info btn-xs" href="{{ route('announce.edit', $item->id)}}">{{__('general.edit') }}</a>
                <form id="delete{{$item->id}}" action="{{ route('announce.destroy', $item->id)}}" method="post">
                  @csrf
                  @method('DELETE')
                </form>
            </td>
           
          </tr>
          @endforeach
         
        </tbody> 
      </table>

    <!-- /.card-body -->
  
  @endsection
</div>
</div>
  @pushOnce('datatables-script')
<script src="{{ asset('/plugins/datatables/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-responsive/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-buttons/js/dataTables.buttons.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-buttons/js/buttons.bootstrap4.min.js') }}"></script>
<script src="{{ asset('/plugins/jszip/jszip.min.js') }}"></script>
<script src="{{ asset('/plugins/pdfmake/pdfmake.min.js') }}"></script>
<script src="{{ asset('/plugins/pdfmake/vfs_fonts.js') }}"></script>
<script src="{{ asset('/plugins/datatables-buttons/js/buttons.html5.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-buttons/js/buttons.print.min.js') }}"></script>
<script src="{{ asset('/plugins/datatables-buttons/js/buttons.colVis.min.js') }}"></script>
  
<script>
  $(function () {
  $("#example1").DataTable({
    "responsive": true, "lengthChange": false, "autoWidth": false,
    "buttons": ["excel","print"]
  }).buttons().container().appendTo('#example1_wrapper .col-md-6:eq(0)');
  $('#example2').DataTable({
    "paging": true,
    "lengthChange": false,
    "searching": false,
    "ordering": true,
    "info": true,
    "autoWidth": false,
    "responsive": true,
  });
});

</script>
  
  <script>
    function confirmDelete(id) {
      let text = 'آیا مطمین استید تا این ریکارد حذف شود؟';
      if (confirm(text) == true) {
        $('form#delete'+id).submit();
    
      } else {
        alert('ریکارد حذف نشد.');
      }
    
    }
    </script>
    
    @endpushOnce